public class Flap extends GGen {

    true => int movedback;

    HalfFlip top --> this;
    HalfFlip bottom --> this;

    0.02 => float layer;

    0 => float layerAngle;

    fun void update(float dt) {
        top.update() => float topAngle;
        bottom.update() => float bottomAngle;

        (topAngle + bottomAngle) / 2.0 => float summedAngle;

        if (summedAngle >= Math.PI) {
            true => movedback;
        }

        0.0 => float adjust;

        if (movedback) {-0.1 => adjust;}

        relPos(Math.cos(summedAngle) * layer, Math.sin(summedAngle) * layer + adjust);
    }

    fun void reset() {
        top.reset();
        bottom.reset();

        true => movedback;
    }

    fun void relPos(float y, float z) {
        top.posZ(z);
        bottom.posZ(z);
        top.posY(y);
        bottom.posY(y);
    }

    fun void open(float speed) {
        reset();
        bottom.flip(speed);

        false => movedback;
    }

    fun void close(float speed) {
        top.flip(speed);
        bottom.setFlippedPos();
    }

    fun void setColor(vec3 color) {
        top.setColor(color);
        bottom.setColor(color);
    }

    fun void bringToFront() {
        top.posZ(0.1);
        bottom.posZ(0.1);
    }

}