1024 => int WINDOW_SIZE;

GScene scene;

GG.scene().backgroundColor( @(0.8,0.8,0.8) );
// GG.scene().backgroundColor( @(0,0,0) );

[KB.KEY_1, KB.KEY_2, KB.KEY_3, KB.KEY_4, KB.KEY_5, KB.KEY_6, KB.KEY_7, KB.KEY_8, 
KB.KEY_Q, KB.KEY_W, KB.KEY_E, KB.KEY_R, KB.KEY_T, KB.KEY_Y, KB.KEY_U, KB.KEY_I,
KB.KEY_A, KB.KEY_S, KB.KEY_D, KB.KEY_F, KB.KEY_G, KB.KEY_H, KB.KEY_J, KB.KEY_K] @=> int KEYMAPS[];


GG.windowTitle( "Split Flap" );

8 => float spawnDistance;
0 => float camPosX;
GG.camera().posZ( spawnDistance );
GG.camera().posX( camPosX );
// GG.camera().orthographic();

GG.camera().lookAt(@(0, 0, 0));
GG.lockCursor();

GG.fullscreen();

1 => int index;

false => int click;
false => int hovered;

0.02 => float speed;

0.1 => float pSpeed;


// setColor(@(1, 0, 0));

0.0 => float warmth;
0.005 => float pWarmth;

Mouse mouse;
spork ~ mouse.start(0);

GlobalMet met;

SplitFlap sfs[24];

StkInstrument insts[24];


for (0 => int i; i < 8; i++) {
    ClickFlap cf @=> sfs[i];
    cf.setSync(false);
}

for (8 => int i; i < 16; i++) {
    HoverFlap hf @=> sfs[i];

}

for (16 => int i; i < 24; i++) {
    ClickFlap hf @=> sfs[i];
    hf.setTargetCadence(175::ms);
}

fun ClickFlap makeClickFlap(string file, dur cadence, float gain, float random) {
    ClickFlap cf;
    cf.attachGlobalMet(met);
    SampleFF sample;
    sample.setSample(file);
    sample.setGain(gain, random);
    cf.setFlapFunc(sample);
    cf.setTargetCadence(cadence);
    return cf;
}

makeClickFlap("/assets/audio/TM88 - KICK (2).wav", 700::ms, 0.5, 0) @=> sfs[16];
makeClickFlap("/assets/audio/basic clap.wav", 1400::ms, 0.2, 0) @=> sfs[17];
makeClickFlap("/assets/audio/dro hat.wav", 175::ms, 0.2, 0.4) @=> sfs[18];
makeClickFlap("/assets/audio/shaker lofi.wav", 700::ms, 0.2, 0.4) @=> sfs[19];

3 => int numRows;

for (0 => int i; i < 24; i++) {
    -2.5 + 0.7 * (i % (24 / numRows)) => sfs[i].posX;
    1.5 - (1.5 * (numRows * (i - (i % (24 / numRows))) / 24)) => sfs[i].posY;

    @(1, 0.6, 0.2) @=> sfs[i].activeColor;

    sfs[i] --> GG.scene();
}

// Chorus c

fun SequenceFF makeSequenceFF(StkInstrument inst, int possibleNotes[], int octave, float gain, float randomGain, float revMix) {
    inst => Gain gainNode => LPF lpf => Chorus c => PRCRev r => dac;
    revMix => r.mix;
    0.2 => c.mix;
    1400 => lpf.freq;

    SequenceFF sff;
    sff.setGain(gain, randomGain);
    inst @=> sff.inst;
    gainNode @=> sff.gainNode;
    sff.setNotes(possibleNotes);

    octave => sff.octave;

    return sff;
}

for (0 => int i; i < 8; i++) {
    Wurley m @=> insts[i];
}

for (8 => int i; i < 16; i++) {
    Wurley m @=> insts[i];
}

0.1 => float backsGain;

sfs[0].setFlapFunc(makeSequenceFF(insts[0], [6], 0, backsGain, 0.3, .5));
sfs[1].setFlapFunc(makeSequenceFF(insts[1], [8], 0, backsGain, 0.3, .5));
sfs[2].setFlapFunc(makeSequenceFF(insts[2], [10], 0, backsGain, 0.3, .5));
sfs[3].setFlapFunc(makeSequenceFF(insts[3], [11], 0, backsGain, 0.3, .5));
sfs[4].setFlapFunc(makeSequenceFF(insts[4], [13], 0, backsGain, 0.3, .5));
sfs[5].setFlapFunc(makeSequenceFF(insts[5], [15], 0, backsGain, 0.3, .5));
sfs[6].setFlapFunc(makeSequenceFF(insts[6], [17], 0, backsGain, 0.3, .5));
sfs[7].setFlapFunc(makeSequenceFF(insts[7], [20], 0, backsGain, 0.3, .5));

sfs[8].setFlapFunc(makeSequenceFF(insts[8], [5, 3], 1, 0.3, 0.2, .5));
sfs[9].setFlapFunc(makeSequenceFF(insts[9], [6, 8, 13], 1, 0.3, 0.2, .5));
sfs[10].setFlapFunc(makeSequenceFF(insts[10], [10, 13, 17], 1, 0.3, 0.2, .5));
sfs[11].setFlapFunc(makeSequenceFF(insts[11], [0 ,1, 5], 2,  0.3, 0.2, .5));
sfs[12].setFlapFunc(makeSequenceFF(insts[12], [1, 3, 8], 2, 0.3, 0.2, .5));
sfs[13].setFlapFunc(makeSequenceFF(insts[13], [5, 12], 2, 0.3, 0.2, .5));
sfs[14].setFlapFunc(makeSequenceFF(insts[14], [10, 15], 2, 0.3, 0.2, .5));
sfs[15].setFlapFunc(makeSequenceFF(insts[15], [12, 17], 2,0.3, 0.2, .5));

fun SequenceFF makeBass(int notes[]) {
    PercFlut inst => Gain g => LPF lpf => dac;
    1500 => lpf.freq;
    return makeSequenceFF(inst, notes, -1, 0.4, 0.1, 0.2);
}

sfs[20].setFlapFunc(makeBass([1]));
sfs[21].setFlapFunc(makeBass([4]));
sfs[22].setFlapFunc(makeBass([8]));
sfs[23].setFlapFunc(makeBass([-1]));

@(0.5, 0.6, 0.6) => vec3 drumsColor;
drumsColor => sfs[16].activeColor;
drumsColor => sfs[17].activeColor;
drumsColor => sfs[18].activeColor;
drumsColor => sfs[19].activeColor;

@(0.8, 0.6, 0.8) => vec3 bassColor;

bassColor => sfs[20].activeColor;
bassColor => sfs[21].activeColor;
bassColor => sfs[22].activeColor;
bassColor => sfs[23].activeColor;

false => int prevClick;
20 => int clickThreshold;
0 => int clickCounter;
false => int startCounting;

GPointLight light --> GSphere cursor --> GG.scene();
cursor.sca(0.1); 
light.falloff(0.7, 1.8); 


false => int clickHold;

vec3 dragPos;

fun void mousePos() {
    while (true) {
        // get click location

        if (mouse.mouseState[mouse.LEFT_CLICK] && !prevClick) {
            if (clickCounter == 0) {
                true => click;
                true => startCounting;
            } else {
                false => click;
            }
        } else {
            false => click;
        }

        if (startCounting) {
            clickCounter++;
            if (clickCounter > clickThreshold) {
                0 => clickCounter;
                false => startCounting;
            }
        }

        click => prevClick;

        // 0 => float targetWarmth;

        // if (click) {
        //     1.0 => targetWarmth;
        // }

        // targetWarmth - warmth => float dWarmth;
        // warmth + dWarmth * pWarmth => warmth;;

        // setColor(@(1,1- warmth * 0.5,1 - warmth * 1.0));

        //1000 + 2000 * warmth => lpf.freq;
       
        GG.mouseX() => float x;
        GG.mouseY() => float y;
        GG.frameWidth() * 1.0 => float screenWidth;
        GG.frameHeight() * 1.0 => float screenHeight;

        vec3 spawnPos;

        // calculate spawn position differently depending on camera mode
        if (GG.camera().mode() == GCamera.ORTHO) {
            // calculate screen aspect
            screenWidth / screenHeight => float aspect;

            // calculate camera frustrum size in world space
            GG.camera().viewSize() => float frustrumHeight;  // height of frustrum in world space
            frustrumHeight * aspect => float frustrumWidth;  // width of frustrum in world space

            // convert from normalized mouse coords to view space coords
            // // (we negate viewY so that 0,0 is bottom left instead of top left)
            // frustrumWidth * (x / screenWidth - 0.5) => float viewX;
            // -frustrumHeight * (y / screenHeight - 0.5) => float viewY;   
            frustrumWidth * (x / (screenWidth / 2.0) - 0.5) => float viewX;
            -frustrumHeight * (y / (screenHeight / 2.0 ) - 0.5) => float viewY;

            // convert from view space coords to world space coords
            GG.camera().posLocalToWorld(@(viewX, viewY, -spawnDistance)) => spawnPos;
        } else {
            // generate ray going from camera through click location
            GG.camera().screenCoordToWorldRay(x, y) => vec3 ray;

            Math.atan(ray.x/ray.z) => float angX;

            Math.atan(ray.y/ray.z) => float angY;

            @(-Math.tan(angX) * spawnDistance, -Math.tan(angY) * spawnDistance, -spawnDistance) => vec3 ray_corrected;

            // calculate spawn position by moving along ray
            // spawnDistance * ray + GG.camera().pos() => spawnPos;
            ray_corrected + GG.camera().pos() => spawnPos;
        }

        cursor.pos(spawnPos);

        for (SplitFlap s : sfs) {

            if (spawnPos.x > s.posX() - s.width / 2 && spawnPos.x < s.posX() + s.width / 2 ) {

                if (spawnPos.y > s.posY() - s.height / 2 && spawnPos.y < s.posY() + s.height / 2 ) {

                    s.hover(true);

                    if (click) { s.onClick(); }
                } else {
                    s.hover(false);
                }

            } else {
                s.hover(false);
            }
            
        }

        for (0 => int i; i < KEYMAPS.size(); i++) {
            if (KB.isKeyDown(KEYMAPS[i])) {
                sfs[i].hover(true);

                sfs[i].onClick();
                // <<<"press">>>;
            }
        }



        if (mouse.mouseState[mouse.LEFT_CLICK]) {
            if (!clickHold) {
                true => clickHold;
                spawnPos => dragPos;
            }
        } else {
            false => clickHold;
        }
        
        10::ms => now;
    }
} spork ~ mousePos();

8 => int testIndex;

fun void test() {
    
    while (true) {
        if (KB.isKeyDown(KB.KEY_BACKSLASH)) {
            sfs[testIndex].singleFlip(0.2, 0.4);
            sfs[testIndex].setTargetColor(@(Math.randomf(),Math.randomf(),Math.randomf()));
        }
        testIndex++;
        if (testIndex >= 16) {
            8 => testIndex;
        }
        87.5::ms => now;
    }
}
spork ~ test();



while( true )
{
    GG.nextFrame() => now;
    if( KB.isKeyDown(KB.KEY_LEFT) )
    {
        camPosX - 0.05 => camPosX;
    }
    if (KB.isKeyDown(KB.KEY_RIGHT)) {
        camPosX + 0.05 => camPosX;
    }

    if (KB.isKeyDown(KB.KEY_UP)) {
        spawnDistance - 0.05 => spawnDistance;
    } 

    if (KB.isKeyDown(KB.KEY_DOWN)) {
        spawnDistance + 0.05 => spawnDistance;
    } 

    GG.camera().posX(camPosX);
    GG.camera().posZ( spawnDistance );
    GG.camera().lookAt(@(0, 0, 0));
    
}