public class HalfFlip extends GGen {

    GPlane plane --> this;
    plane.posY(0.5);

    false => int flipped;
    false => int doFlip;

    0.0 => float angle;
    0.03 => float speed;

    0.0 => float zAdjust;

    fun float update() {
        if (doFlip) {

            angle + speed => angle;

            if (angle >= Math.PI) {
                false => doFlip;
                true => flipped;
                Math.PI >= angle;
            }

            plane.rotX(angle);
            plane.posZ(Math.sin(angle) * 0.5);
            plane.posY(Math.cos(angle) * 0.5);
        }

        return angle;
    }

    fun void setZAdjust(float z) {
        z => zAdjust;
    } 

    fun void flip(float speed) {
        speed => this.speed;
        true => doFlip;
        plane.posZ(0.1);
    }

    fun void setFlippedPos() {
        plane.rotX(Math.PI);
        plane.posY(-0.5);
        plane.posZ(0);
        true => flipped;
    }

    fun int isFlipped() {
        return this.flipped;
    }

    fun void reset() {
        false => flipped;
        0.0 => angle;
        plane.rotX(angle);
        plane.posY(0.5);
        plane.posZ(0);
    }

    fun void setColor(vec3 color) {
        plane.mat().color(color);
    }

}