public class SequenceFF extends FlapFunction {

    [0] @=> int possiblenotes[];

    false => int random;

    StkInstrument inst;
    Gain gainNode;

    fun void setNotes(int notes[]) {
        notes @=> possiblenotes;
    }

    0 => int i;

    1 => int octave;

    0.5 => float instGain;
    0 => float randomGain;

    fun void setGain(float instGain, float randomGain) {
        instGain => this.instGain;
        randomGain => this.randomGain;
    }

    fun void onFlip(float speed, float gain) {

        // freq
        i => int winner;

        if (random) {
            Math.random2( 0, possiblenotes.size() -1 ) =>  winner;  
        } else {
            i++;
            if (i >= possiblenotes.size()) {
                0 => i;
            }
        }
        
        Std.mtof( 47 + octave * 12 + possiblenotes[winner] ) => inst.freq;

        // pluck!
        if (this.on) {

            // <<<gain * (instGain + Math.randomf() * randomGain)>>>;

            gain * (instGain + Math.randomf() * randomGain) => gainNode.gain;
            1 => inst.noteOn;
        } else {
            gain * speed * 5 * (instGain + Math.randomf() * randomGain) => inst.noteOn;
        }
    }

    fun void onStop() {
        // <<<"stop">>>;
        1 => inst.noteOff;
    }

}