 public class SplitFlap extends GGen {

    3 => int numFlaps;

    Flap flaps[numFlaps];

    GGen splitflap --> this;

    FlapFunction flapFunc;

    Shred @ currShred;

    1.2 => float height;
    0.5 => float width;

    for (Flap f : flaps) {
        f.sca(0.6);
        f.reset();
        f --> splitflap;
    }

    flaps[(0) % numFlaps].close(0.1);
    flaps[1].open(0.1);
    flaps[(2) % numFlaps].reset();

    fun void setColor(vec3 color) {
        for (Flap f :  flaps) {
            f.setColor(color);
        }
    }

    fun void setScale(float sca) {
        height * sca => height;
        width * sca => width;

        this.sca(sca);
    }

    0 => float speed;
    0 => float targetSpeed;
    0.3 => float pSpeed;

    1 => int index; 

    false => int enabled;


    @(1,1,1) => vec3 activeColor;
    @(1,1,1) => vec3 defaultColor;

    @(1,1,1) => vec3 targetColor; 

    // => dur cadence;


    true => flapFunc.on;

    fun void flip() {
        while (true) {
            targetSpeed - speed => float dSpeed;

            speed + dSpeed * pSpeed => speed;
            40.0::ms * (1/speed)=> dur cadence;
    
            singleFlip(speed);

            if (speed < 0.02 && targetSpeed < 0.02) {
                false => enabled;

                false => flapFunc.on;
                me.exit();
            }

            cadence => now;
        }
    }

    fun void singleFlip(float speed) {
        singleFlip(speed, 1.0);
    }

    fun void singleFlip(float speed, float gain) {
        flaps[(index - 1) % numFlaps].reset();
        flaps[(index) % numFlaps].close(speed);
        flaps[(index + 1) % numFlaps].open(speed);
        flaps[(index - 2) % numFlaps].setColor(targetColor);
        index++;

        flapFunc.onFlip(speed, gain);
    }
    
    fun void setSpeed(float targetSpeed) {
        targetSpeed => this.targetSpeed;
        if (targetSpeed != 0 && !enabled) {
            spork ~ this.flip() @=> currShred;
            true => enabled;
        }
    } 

    fun void setCadence(dur cadence) {
        if (enabled) {
            currShred.exit();
        }
        40.0 * (1/(cadence / 1::ms)) => this.targetSpeed;
        targetSpeed => speed;

        spork ~ this.flip() @=> currShred;
        true => enabled;
        
    }

    fun void setFlapFunc(FlapFunction ff) {
        ff @=> this.flapFunc;
    }

    fun void setTargetColor(vec3 nextColor) {
        nextColor => targetColor;
        // <<<nextColor>>>;
    }

    fun void onClick() {
    }

    fun void hover(int hovered) {
        if (hovered) {
            // setSpeed(0.2);
        } else {
        }
    }
} 